/***
 * Excerpted from "Domain-Driven Design Using Naked Objects",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/dhnako for more book information.
***/
public class CarRepositoryInMemory 
        extends AbstractFactoryAndRepository
        implements CarRepository {
    ...
    @Hidden
    public List<Car> findCarsWithoutRecentService(
            final Model model, final Integer months) {
        final CalendarDate earlierDate = 
            calendarService.today().plusMonths(-months);
        return allMatches(Car.class, new Filter<Car>() {
            public boolean accept(Car car) {
                if (car.getModel() != model) return false;
                Service service = car.mostRecentService();
                return service != null && 
                       service.getBookedInAndReady()
                              .start().isBefore(earlierDate);
            }});
    }
    ...
    private CalendarService calendarService;
    public void setCalendarService(
            final CalendarService calendarService) {
        this.calendarService = calendarService;
    }
}
